/* splitter⥸塼Υ󥿡ե */
#ifndef _splitter_h_included_
#define _splitter_h_included_

#include <anthy/dic.h>
#include <anthy/xstr.h>
#include <anthy/wtype.h>
#include <anthy/segclass.h>

#ifdef __cplusplus
extern "C" {
#endif

#if 0	/* Patched by G-HAL, Thu,13 Nov,2008 - Sat,17 Oct,2009 */
/* ѥ᡼ */
#define RATIO_BASE 256
#define OCHAIRE_SCORE 5000000
#else
/* ̥եذư */
#endif

/** splitterΥƥȡ
 * ǽζ꤫anthy_contextβޤͭ
 */
struct splitter_context {
  /** splitterǻѤ빽¤ */
  struct word_split_info_cache *word_split_info;
  int char_count;
  int is_reverse;
  struct char_ent {
    xchar *c;	/* Ѵ, Commented by G-HAL, Sun,19 Apr,2009 */
    int seg_border;
    int initial_seg_len;/* ǽʸʬκݤˤϤޤäʸ᤬
			   ФĹ */
    enum seg_class best_seg_class;
    struct meta_word* best_mw; /* ͥ褷ƻȤmetaword */
	int* hint;	/* ʸڤΥҥƥ󥰾, Patched by G-HAL, Mon,20 Apr,2009 */
  }*ce;

  /** Ϥ줿, Patched by G-HAL, Sat,25 Apr,2009, Thu,12 Nov,2009 */
  struct prev_commit_t {
	  enum seg_class seg_class;				/**< ʻ쥯饹 */
	  xstr	yomi;							/**< ɤ */
	  xstr	cand;							/**< Ѵ */
	  struct ucdic_seg_info* seg_ucinfo;	/**< 㸡Ѿ */
  } prev_commit;
};

#if 0		/* Patched by G-HAL, Sun,17 May,2009, Fri,26 Jun,2009 */
/* Υåξ */
enum constraint_stat {
  unchecked, ok, ng
};
#else
/** Υåξ
 */
enum constraint_stat {
	unchecked,			/**< ̤ */
	ng_by_unsuitable,	/**< Բ */
	ng_by_border,		/**< ԲġâϢ롿ʬ򤷤ϻѲǽ⤷ʤ */
	ng,					/**< Բ */
	eos,				/**< դǻѲǽ */
	ok,					/**< Ѳǽ */
};
#endif

/* ȤꤢŬ䤷Ƥߤ꤬Фʬह */
enum metaword_type {
  /* ߡ : seginfoʤ */
  MW_DUMMY,
  /* wordlist0 or Ĵޤ */
  MW_SINGLE,
  /* ̤metawordĤޤ: metaword +  ʤ :seginfomw1 */
  MW_WRAP,
  /* ʣƬΡ, Commented by G-HAL, Wed,22 Jul,2009 */
  MW_COMPOUND_HEAD,
  /* ʣӥΡ, Commented by G-HAL, Wed,22 Jul,2009 */
  MW_COMPOUND,
  /* ʣΥ꡼հʸ, Commented by G-HAL, Wed,22 Jul,2009 */
  MW_COMPOUND_LEAF,
  /* ʣθġʸ礷ưĤʸȤƤߤ */
  MW_COMPOUND_PART,
  /* ưϢѷ + ƻ */
  MW_V_RENYOU_A,
  /* ưϢѷ + ̾ */
  MW_V_RENYOU_NOUN,
  /*  */
  MW_NUMBER,
  /* */
  MW_learned_min,					/**< 羮ӤˤȽ, Patched by G-HAL, Tue,24 Feb,2009 */
  MW_ochaire_min,					/**< 羮ӤˤȽ, Patched by G-HAL, Tue,24 Feb,2009 */
  MW_OCHAIRE,						/**< OCHAIREؽͳƬʸ˼ΩͭꡢǸʸ°ͭ */
  MW_OCHAIREwithoutDEP,				/**< OCHAIREؽͳƬʸ˼ΩͭꡢǸʸ°̵, Patched by G-HAL, Sat,24 Jan,2009 */
  MW_OCHAIREwithoutINDEP,			/**< OCHAIREؽͳƬʸμΩ̵Ǹʸ°ͭ, Patched by G-HAL, Sun,08 Feb,2009 */
  MW_OCHAIREwithoutINDEPwithoutDEP,	/**< OCHAIREؽͳƬʸμΩ̵Ǹʸ°̵, Patched by G-HAL, Sun,08 Feb,2009 */
  MW_ochaire_max,					/**< 羮ӤˤȽ, Patched by G-HAL, Tue,24 Feb,2009 */
  MW_CANDHISTORY,					/**< CAND_HISTORYؽͳ, Patched by G-HAL, Tue,04 Nov,2008 */
  MW_learned_max,					/**< 羮ӤˤȽ, Patched by G-HAL, Tue,24 Feb,2009 */
  /* */
  MW_END
};

#define MW_FEATURE_NONE 0
#define MW_FEATURE_SV 1
#define MW_FEATURE_WEAK_CONN 2
#define MW_FEATURE_SUFFIX 4
#define MW_FEATURE_NUM 16
#define MW_FEATURE_CORE1 32
#define MW_FEATURE_DEP_ONLY 64
#define MW_FEATURE_HIGH_FREQ 128
#define MW_FEATURE_WEAK_SEQ 256

/*
 * meta_word: θоݤȤʤ
 * ñword_listޤΤ¾ˤĤμब롥
 *
 */
struct meta_word {
  int from, len;
  /* ʸᶭθФ˻Ѥ륹 */
  int score;
  /* λ˻Ѥ륹 */
  int struct_score;
  int	extra_score;			/**< ؽͳɲå, Patched by G-HAL, Wed,04 Feb,2009 */
  /* ξ */
  int dep_word_hash;
  int mw_features;
  wtype_t core_wt;
  enum dep_class dep_class;
  /**/
  enum seg_class seg_class;
  enum constraint_stat can_use; /* ȶ˸٤äƤʤ */
  enum metaword_type type;
  int ochaire_opposite;			/**< CAND_HISTORYؽͳmetawordOCHAIREй⡼ɤǻѤե饰, Patched by G-HAL, Mon,17 Nov,2008 */
  struct word_list *wl;
  int ochaire_phrase_score;		/**< ؽͳmetawordʸ100 + ̡ͥ99ͥˤΣ, Patched by G-HAL, Fri,14 Nov,2008, Mon,27 Apr,2009 */
  int ochaire_total_len;		/**< OCHAIREؽͳmetawordʸ, Patched by G-HAL, Mon,17 Nov,2008 */
  struct meta_word* mw1_left;	/**< ʣ졦OCHAIREؽͳ褹ξΡ¦metaword, Patched by G-HAL, Fri,14 Nov,2008 */
  struct meta_word* mw1_right;	/**< ʣ졦OCHAIREؽͳ褹ξΡ¦metaword, Patched by G-HAL, Thu,27 Aug,2009 */
  struct meta_word *mw1, *mw2;	/**< ʣξϡmetawordƤmetaword餷mw1  mw2 Ϣ뤷ơmetawordꤵ餷
								 *   OCHAIREؽξϡmw1 ¦ʸ餷 */
  xstr cand_hint;
  int	cand_hint_freq;				/**< cand_hint μǤ, Patched by G-HAL, Thu,20 Nov,2008 */
  int	cand_hint_learned_freq;		/**< cand_hint γؽǡǤ, Patched by G-HAL, Sat,21 Feb,2009 */
  int	cand_hint_depth_of_dep;		/**< cand_hint °ο, Patched by G-HAL, Thu,20 Nov,2008 */
  int	cand_hint_length_of_dep;	/**< cand_hint °ʸ, Patched by G-HAL, Sat,24 Jan,2009 */

  int nr_parts;

  /* listΥ */
  struct meta_word *next;
};

int anthy_init_splitter(void);
void anthy_quit_splitter(void);

#if 0	/* Patched by G-HAL, Sun,19 Apr,2009 - Mon,20 Apr,2009 */
void anthy_init_split_context(xstr *xs, struct splitter_context *, int is_reverse);
#else
extern void anthy_init_split_context( const xstr* const xs, const int* const lattice_hint, struct splitter_context* sc, int is_reverse );
#endif

#if 0	/* Patched by G-HAL, Mon,20 Apr,2009 */
#else
/* ʸ󤫤ʸڤΥҥȾ */
extern const int* const anthy_convert_hint_border( const xstr* const in_xs, xstr* const out_xs );
#endif

/*
 * mark_border(context, l1, l2, r1);
 * l1r1δ֤ʸ򸡽Ф롢l1l2δ֤϶ˤʤ
 */
#if 0		/* Patched by G-HAL, Sun,19 Apr,2009 */
void anthy_mark_border(struct splitter_context *, int from, int from2, int to);
#else
extern void anthy_mark_border( struct splitter_context *, int from, int from2, int to, int is_resize );
#endif
#if 0	/* Patched by G-HAL, Thu,27 Nov,2008 */
void anthy_commit_border(struct splitter_context *, int nr,
		   struct meta_word **mw, int *len);
#else
extern void anthy_commit_border( struct splitter_context* const sc, int nr_segments,
						 struct meta_word* const * const mw, const int* const seg_len,
						 const unsigned int* const extra_flag );
#endif
void anthy_release_split_context(struct splitter_context *c);

/* Фʸξ */
int anthy_get_nr_metaword(struct splitter_context *, int from, int len);
struct meta_word *anthy_get_nth_metaword(struct splitter_context *,
					 int from, int len, int nth);
/**/
int anthy_dep_word_hash(xstr *xs);


#ifdef __cplusplus
}
#endif

#endif
