/**@file
 *			Patches for Anthy, by G-HAL
 *@brief	㼭ι¤ǡ
 *@date		Sat,17 Oct,2009 - Mon,19 Oct,2009
 *@date		Sun,01 Nov,2009
 *@date		Thu,12 Nov,2009 - Fri,13 Nov,2009
 *@author	Copyright(C)2009 G-HAL
 */
#ifndef _ucdict_h_included_
#define _ucdict_h_included_

#if !defined(__STDC_LIMIT_MACROS)
# define	__STDC_LIMIT_MACROS
#endif
#include <stdint.h>
#include <limits.h>

#ifdef __cplusplus
extern "C" {
#endif

/** 㼭Υե饰
 *@comment
 *	ĹǤ intФơӥåĹԤΤϷʤΤ
 *	Anthy δܹ¤ʤäƤΤ̵
 */
enum ucdict_flag {
	UCDICT_PRIORITY_VALUE			= 0x0000000F,	/**< ͥ */
	UCDICT_PRIORITY_MINUS			= 0x00000010,	/**< ͥ٤ϥޥʥ */
	UCDICT_PRIORITY					= (UCDICT_PRIORITY_MINUS | UCDICT_PRIORITY_VALUE),	/**< ͥ٥ӥå */
	UCDICT_NEIGHBOR_ONLY			= 0x00000020,	/**< ʸᣱȥʸᣲܤƤΤŬ */
	UCDICT_SEG1_NODE_DEPTYPE_FLAGS	= 0x00000300,	/**< ʸᣱ°ηޥ */
	UCDICT_SEG1_NODE_WILDCARD_DEP	= 0x00000000,	/**< ʸᣱ°ϥ磻ɥ */
	UCDICT_SEG1_NODE_NO_DEP			= 0x00000100,	/**< ʸᣱ°줬̵ */
	UCDICT_SEG1_NODE_HAVE_DEP		= 0x00000200,	/**< ʸᣱ°ġġӥΡ */
	UCDICT_SEG1_LEAF_HAVE_DEP		= 0x00000400,	/**< ʸᣱ°ġġüΡ */
	UCDICT_SEG1_NODE_HAVE_WT_S		= 0x00001000,	/**< ʸᣱʻ콪üꤵƤ */
	UCDICT_SEG1_NODE_HAVE_WT_C		= 0x00002000,	/**< ʸᣱʻѷꤵƤ */
	UCDICT_SEG1_NODE_HAVE_WT_H		= 0x00004000,	/**< ʸᣱʻʬꤵƤ */
	UCDICT_SEG1_NODE_HAVE_WT		= 0x00008000,	/**< ʸᣱʻ쾮ʬꤵƤ */
	UCDICT_SEG2_NODE_DEPTYPE_FLAGS	= 0x00030000,	/**< ʸᣲ°ηޥ */
	UCDICT_SEG2_NODE_WILDCARD_DEP	= 0x00000000,	/**< ʸᣲ°ϥ磻ɥ */
	UCDICT_SEG2_NODE_NO_DEP			= 0x00010000,	/**< ʸᣲ°줬̵ */
	UCDICT_SEG2_NODE_HAVE_DEP		= 0x00020000,	/**< ʸᣲ°ġġӥΡ */
	UCDICT_SEG2_LEAF_HAVE_DEP		= 0x00040000,	/**< ʸᣲ°ġġüΡ */
	UCDICT_SEG2_NODE_HAVE_WT_S		= 0x00100000,	/**< ʸᣲʻ콪üꤵƤ */
	UCDICT_SEG2_NODE_HAVE_WT_C		= 0x00200000,	/**< ʸᣲʻѷꤵƤ */
	UCDICT_SEG2_NODE_HAVE_WT_H		= 0x00400000,	/**< ʸᣲʻʬꤵƤ */
	UCDICT_SEG2_NODE_HAVE_WT		= 0x00800000,	/**< ʸᣲʻ쾮ʬꤵƤ */
	UCDICT_FLAGS_SENTRY								/**< ʼ */
};

#define	UC_PRIO_MIN					0		/**< 㼭Ρͥ٤κ */
#define	UC_PRIO_MAX					15		/**< 㼭Ρͥ٤κǹ */
#define	UCDICT_SEG_DISTANCE_MIN		1		/**< ŬȽκݤˡʸ֤ûǤɤޤΥ줿꤫鸡뤫1:٤ */
#define	UCDICT_SEG_DISTANCE_MAX		2		/**< ŬȽκݤˡʸ֤ǤɤޤΥ줿ޤǸ뤫1:٤ޤǡ */
#define	UCDICT_WT_WILDCARD			"*"		/**< ʻΥ磻ɥʸ */
#define	UCDICT_WT_H_KEY				'H'		/**< ʻʻܤΥ */
#define	UCDICT_WT_C_KEY				'C'		/**< ʻγѷܤΥ */
#define	UCDICT_WT_S_KEY				'S'		/**< ʻ°ܤΥ */


/** 㼭θ
 */
struct ucdic_seg_info {
	uint32_t		id_base;		/**< ܤΥϥåfinalize */
	int				id_base_fin;	/**< ܤΥϥåfinalize */
	int				have_dep;		/**< °(true)ݤ(false) */
	uint32_t		id_wo_dep;		/**< °̵Υϥåfinalize */
	uint32_t		id_w_dep;		/**< °դΥϥåfinalize */
	const char*		wt;				/**< ʻʾʬ */
	const char*		wt_h;			/**< ʻʬ */
	const char*		wt_c;			/**< ʻʳѷ */
	const char*		wt_s;			/**< ʻ° */
};


#ifdef __cplusplus
}
#endif

#endif /* _ucdict_h_included_ */
/* [ End of File ] */
